<?php
namespace OrganizationsManagement\Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Util\InstanceProvider;


class NotificationParameters{
    
    public function findNotificationParametersProdOrg(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $serviceNotificationParameters = InstanceProvider::getService()->getNotificationParameters();
            $dataSet = $serviceNotificationParameters->findNotificationParametersProdOrg($conditions);
            $response->addDataSet(new DataSet('notificationParameters', $dataSet));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
    public function findServicesConfigurationProdOrgs(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $ServicesConfiguration = InstanceProvider::getService()->getNotificationParameters();
            $dataSet = $ServicesConfiguration->findServicesConfigurationProdOrgs($conditions);
            $response->addDataSet(new DataSet('servicesConfigurationProdOrgs', $dataSet));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
    public function saveServicesConfigurationProdOrgs(Request\DataSet $request, Response $response)
    {
        try {
            $rows = $request->getDataSet()->getRows();
            $ServicesConfigurationProdOrg = InstanceProvider::getService()->getNotificationParameters();
            $ServicesConfigurationProdOrg->saveServicesConfigurationProdOrgs($rows);
            
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
   
    public function findServicesConfigurationProd(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $ServicesConfigurationProd = InstanceProvider::getService()->getNotificationParameters();
            $dataSet = $ServicesConfigurationProd->findServicesConfigurationProd($conditions);
            $response->addDataSet(new DataSet('servicesConfigurationProd', $dataSet));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
     
    public function saveServicesConfigurationProd(Request\DataSet $request, Response $response)
    {
        try {
            $rows = $request->getDataSet()->getRows();
            $ServicesConfigurationProd = InstanceProvider::getService()->getNotificationParameters();
            $ServicesConfigurationProd->saveServicesConfigurationProd($rows);
            
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
}