<?php

namespace OrganizationsManagement\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Service\OmCentralCallbackAssinaturaService;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\HTTP\Kernel;

class OmCentralCallbackAssinaturaController {

    protected $omCentralAsssinaservice;
    protected $httpKernel;

    public function __construct(OmCentralCallbackAssinaturaService $omCentralAsssinaservice, Kernel $httpKernel){
        $this->omCentralAsssinaservice = $omCentralAsssinaservice;
        $this->httpKernel = $httpKernel;
    }
    
    public function callbackCertsing(Request $request, Response $response){
        try {
            $parametros = $request->getParameters();
            $nrorg = $this->httpKernel->getHttpRequest()->getHeaders()->get("nrorg");
            
            $this->omCentralAsssinaservice->callbackCertsing($parametros, $nrorg);

        } catch(\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }

}