<?php
namespace OrganizationsManagement\Controller;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use OrganizationsManagement\Service;

class Pais extends Simple {

    private $servicePais;

    public function __construct(Service\Pais $countryService){
        $this->servicePais = $countryService;
    }

    public function obtemTodos(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $filters = $request->getFilterCriteria()->getConditions();
            $paises = $this->servicePais->obtemTodos($filters);
            $response->addDataSet(new DataSource\DataSet('countries', $paises));
        } catch(\Exception $ex){
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
        }
    }
}