<?php

namespace OrganizationsManagement\Repository;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Geral\Entities\Operador;

class LayoutExportation {
    /** @var EntityManager **/
    protected $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    /**
     * @param $tableName
     * @param $dbUser
     * @return array
     */
    public function getOperatorConstraintByTable($tableName, $dbUser){
        $query = "SELECT CONSTRAINT_NAME, CONSTRAINT_TYPE, TABLE_NAME
                    FROM ALL_CONSTRAINTS
                   WHERE TABLE_NAME = :TABLE_NAME
                     AND R_CONSTRAINT_NAME = :R_CONSTRAINT_NAME
                     AND OWNER = :OWNER";

        $params = array(
            'TABLE_NAME' => $tableName,
            'OWNER' => $dbUser,
            'R_CONSTRAINT_NAME' => Operador::TABLE_PK_NAME
        );
        return $this->entityManager->getConnection()->fetchAll($query, $params);
    }
} 