/************************************************************************************
    Trigger para registro na logopera das alteraes feitas na retirada da produo
*************************************************************************************

Criado em  : 12/08/2014
       Por : Marcelo e Srgio
Descrio:
       - Registra na logopera sempre que houver uma alterao na retirada da 
         produo deixando a Quantidade Teria diferente da Quantidade Prevista
Trigger:
      00NK_CDPTRGO - DTULTATU_LOTITRETIEST
Util :
       - Erro : raise_application_error(-20501, 'Mensagem', True);
*/
CREATE OR REPLACE TRIGGER LOG_CDP_LOTITRETIEST
AFTER UPDATE OF QTREJRETPROD
ON LOTITRETIEST FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);

  V_QTDE_ITEMRETIEST FLOAT;
BEGIN
   V_IDTIPOOPER := '2';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_CDFILLOGOPER := '';
   BEGIN
      SELECT IT.QTPRERETPROD
       INTO V_QTDE_ITEMRETIEST
       FROM ITEMRETIEST IT
      WHERE IT.CDFILIAL     = :NEW.CDFILIAL
        AND IT.NRRETEST     = :NEW.NRRETEST
        AND IT.NRSEQRETPROD = :NEW.NRSEQRETPROD
        AND IT.CDPRODUTO    = :NEW.CDPRODUTO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_QTDE_ITEMRETIEST := NULL;
      END;
   END;
   IF V_QTDE_ITEMRETIEST IS NOT NULL THEN
      IF V_QTDE_ITEMRETIEST <> :NEW.QTREJRETPROD THEN
         NMUSUARIO(V_NMOPERADOR);
         WEBTUNNING(V_DSREMOTEADDR,
                    V_DSREMOTEHOST,
                    V_DSSERVERRDM,
                    V_DSSERVMETHOD, --VRAPROVPRODRET, CDOPERADORRETI, DTRETIRADA
                    V_DSREMOTEOPER);
         V_ITPESQ := :NEW.CDFILIAL||:NEW.NRRETEST||:NEW.NRSEQRETPROD||:NEW.CDPRODUTO;
         V_DESC   := 'Alteracao Qtde - Valor Anterior: '||:OLD.QTREJRETPROD||' Valor Atual: '||:NEW.QTREJRETPROD||' Teor: '||:NEW.VRAPROVPRODRET||' Operador: '||:NEW.CDOPERADORRETI||' Data: '||:NEW.DTRETIRADA;
         IF (V_DESC IS NOT NULL) THEN
            V_DESC := SUBSTR(V_DESC, 1, 300);
            INSERT INTO LOGOPERA
               (NMTABELA,
                DTOPERACAO,
                NMRESPOPER,
                IDTIPOOPER,
                DSOPERACAO,
                CDPESQITEM,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER,
                CDFILLOGOPER)
            VALUES
               ('LOTITRETIEST',
                SYSDATE,
                NVL(V_NMOPERADOR,' '),
                V_IDTIPOOPER,
                V_DESC,
                V_ITPESQ,
                V_DSSERVERRDM,
                V_DSREMOTEADDR,
                V_DSREMOTEHOST,
                V_DSSERVMETHOD,
                V_DSREMOTEOPER,
                V_CDFILLOGOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_LOTITRETIEST','5.75.000'); END;
/

