CREATE TABLE AUTPERFILACESSOSOLI
(
	NRAUTPERFILACESSOSOLI NUMBER NOT NULL,
	NRPERFILACESSO        NUMBER                              NOT NULL,
	IDAUTNECECOMP     	  VARCHAR2(30) NULL,
	IDAUTLANCSOLI  	  	  VARCHAR2(30) NULL,
	IDAUTALTEPRODSOLI     VARCHAR2(30) NULL,
	IDAUTALTESOLI  	      VARCHAR2(30) NULL,
	PEALTEQTDESOLI        FLOAT NULL,
	CDFILCENTCMP      	  VARCHAR2(4)   NULL,
	NRORG                 NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           	  VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        	  DATE            DEFAULT SYSDATE,
    DTULTATU          	  DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     	  NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    	  VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       	  NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      	  VARCHAR2(12)    DEFAULT '1',
	  CONSTRAINT CKC_IDAUTNECECOMP_SOL CHECK (IDAUTNECECOMP IN ('INCLUIR_DTENTREGA', 'EXCLUIR_DTENTREGA', 'INCLUIR_PRODUTO', 'ALTERAR_PRODUTO', 'EXCLUIR_PRODUTO', 'AUMENTAR_QUANTIDADE', 'DIMINUIR_QUANTIDADE', 'ALTERAR_DTENTREGA')),
	  CONSTRAINT CKC_IDAUTLANCSOLI_SOL CHECK (IDAUTLANCSOLI IN ('INCLUIR_DTENTREGA', 'EXCLUIR_DTENTREGA', 'INCLUIR_PRODUTO', 'ALTERAR_PRODUTO', 'EXCLUIR_PRODUTO', 'AUMENTAR_QUANTIDADE', 'DIMINUIR_QUANTIDADE')),
	  CONSTRAINT CKC_IDAUTALTEPRODSOLI_SOL CHECK (IDAUTALTEPRODSOLI IN ('ALTERAR_PRODUTO', 'EXCLUIR_PRODUTO', 'AUMENTAR_QUANTIDADE', 'DIMINUIR_QUANTIDADE')),
	  CONSTRAINT CKC_IDAUTALTESOLI_SOL CHECK (IDAUTALTESOLI IN ('ALTERAR_DTENTREGA', 'AUMENTAR_QUANTIDADE', 'DIMINUIR_QUANTIDADE')),
	  CONSTRAINT CKC_IDATIVO_AUTGRUPOPSOLI_SOL CHECK (IDATIVO IN ('S', 'N')),
	  CONSTRAINT PK_AUTPERFILACESSOSOLI PRIMARY KEY (NRAUTPERFILACESSOSOLI)
)
/

CREATE SEQUENCE SEQ_AUTPERFILACESSOSOLI INCREMENT BY 1 MINVALUE 1
/

CREATE INDEX IN_AUTPERFILACESSOSOLI_01 ON AUTPERFILACESSOSOLI(NRPERFILACESSO)
/